!
subroutine DF18(X, Y, XX, DY, Error)
!   DY  Y(X)
!    X1 ... XN   .
real, intent(in):: X(:), Y(:), XX
real:: DY, H, H2, Ym, Yn, Yp, P
integer:: Error, k, n, L, R
!begin
  n=size(X)
  if(n<3) then
    Error=65; return
  end if
  Error=0
  H=X(2)-X(1); H2=2.0*H
  L=1; R=n
  do while(L+1<R)
    k=(L+R)/2
    if(X(k)<=XX) then; L=k
                 else; R=k
    end if
  end do
  if(XX<=X(L)) then
    if(L==1) then
      DY=(-Y(3)-3.0*Y(1)+4.0*Y(2))/H2
    else
      DY=(-Y(L-1)+Y(R))/H2
    end if
    return
  end if
  if(L==1) then
    P=(XX-X(2))/H
    Ym=Y(1); Yn=Y(2); Yp=Y(3)
  else if(R==n) then
    if(XX>=X(n)) then
      DY=(Y(n-2)+3.0*Y(n)-4.0*Y(n-1))/H2
      return
    end if
    P=(XX-X(n-1))/H
    Ym=Y(n-2); Yn=Y(n-1); Yp=Y(n)
  else if(XX-X(L) <= X(R)-XX) then
    P=(XX-X(L))/H
    Ym=Y(L-1); Yn=Y(L); Yp=Y(R)
  else
    P=(XX-X(R))/H
    Ym=Y(L); Yn=Y(R); Yp=Y(R+1)
  end if
  DY=(-2.0*P*Yn + (P-0.5)*Ym + (P+0.5)*Yp)/H
  return
end subroutine DF18
